#   ============================================================================
#   @file   link.mk
#
#   @path   $(DSPLINK)/make/WinCE/OMAPL138/
#
#   @desc   This makefile contains rules to link sources.
#
#   @ver    1.65.01.06
#   ============================================================================
#   Copyright (C) 2002-2009, Texas Instruments Incorporated -
#   http://www.ti.com/
#
#   Redistribution and use in source and binary forms, with or without
#   modification, are permitted provided that the following conditions
#   are met:
#   
#   *  Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#   
#   *  Redistributions in binary form must reproduce the above copyright
#      notice, this list of conditions and the following disclaimer in the
#      documentation and/or other materials provided with the distribution.
#   
#   *  Neither the name of Texas Instruments Incorporated nor the names of
#      its contributors may be used to endorse or promote products derived
#      from this software without specific prior written permission.
#   
#   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
#   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
#   THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
#   PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
#   EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#   PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
#   OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
#   WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
#   OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
#   EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#   ============================================================================


ifndef LINK_MK

define LINK_MK
endef


include $(MAKEROOT)$(DIRSEP)$(BUILDOS)$(DIRSEP)systools.mk
include $(MAKEROOT)$(DIRSEP)gendefs.mk
include $(MAKEROOT)$(DIRSEP)$(BUILDOS)$(DIRSEP)osdefs.mk
include $(MAKEROOT)$(DIRSEP)rulebase.mk

-include $(BUILDOS)$(DIRSEP)$(COMP_DETAILS)
-include $(BUILDOS)$(DIRSEP)$(TI_DSPLINK_GPPOSVERSION)$(DIRSEP)$(COMP_DETAILS)


#   ============================================================================
#   Clear environment variables
#   ============================================================================

INCLUDE     :=
LIB         :=


#   ============================================================================
#   Search path for standard libraries
#   ============================================================================

TARGETLIBS_REL := $(_PROJECTROOT)$(DIRSEP)CESYSGEN$(DIRSEP)SDK$(DIRSEP)lib$(DIRSEP)$(_TGTCPU)$(DIRSEP)$(WINCEDEBUG)$(DIRSEP)coredll.lib  \
                  $(_PROJECTROOT)$(DIRSEP)CESYSGEN$(DIRSEP)SDK$(DIRSEP)lib$(DIRSEP)$(_TGTCPU)$(DIRSEP)$(WINCEDEBUG)$(DIRSEP)corelibc.lib \
                  $(_PROJECTROOT)$(DIRSEP)CESYSGEN$(DIRSEP)OAK$(DIRSEP)lib$(DIRSEP)$(_TGTCPU)$(DIRSEP)$(WINCEDEBUG)$(DIRSEP)ceddk.lib 

SOURCELIBS_REL := $(_PROJECTROOT)$(DIRSEP)CESYSGEN$(DIRSEP)SDK$(DIRSEP)lib$(DIRSEP)$(_TGTCPU)$(DIRSEP)$(WINCEDEBUG)$(DIRSEP)corelibc.lib \
                  $(_PROJECTROOT)$(DIRSEP)CESYSGEN$(DIRSEP)SDK$(DIRSEP)lib$(DIRSEP)$(_TGTCPU)$(DIRSEP)$(WINCEDEBUG)$(DIRSEP)coredll.lib  \
                  $(_PROJECTROOT)$(DIRSEP)CESYSGEN$(DIRSEP)OAK$(DIRSEP)lib$(DIRSEP)$(_TGTCPU)$(DIRSEP)$(WINCEDEBUG)$(DIRSEP)ceddk.lib 

TARGETLIBS_DEB := $(_PROJECTROOT)$(DIRSEP)CESYSGEN$(DIRSEP)SDK$(DIRSEP)lib$(DIRSEP)$(_TGTCPU)$(DIRSEP)$(WINCEDEBUG)$(DIRSEP)coredll.lib  \
                  $(_PROJECTROOT)$(DIRSEP)CESYSGEN$(DIRSEP)SDK$(DIRSEP)lib$(DIRSEP)$(_TGTCPU)$(DIRSEP)$(WINCEDEBUG)$(DIRSEP)corelibc.lib \
                  $(_PROJECTROOT)$(DIRSEP)CESYSGEN$(DIRSEP)OAK$(DIRSEP)lib$(DIRSEP)$(_TGTCPU)$(DIRSEP)$(WINCEDEBUG)$(DIRSEP)ceddk.lib 

SOURCELIBS_DEB := $(_PROJECTROOT)$(DIRSEP)CESYSGEN$(DIRSEP)SDK$(DIRSEP)lib$(DIRSEP)$(_TGTCPU)$(DIRSEP)$(WINCEDEBUG)$(DIRSEP)corelibc.lib \
                  $(_PROJECTROOT)$(DIRSEP)CESYSGEN$(DIRSEP)SDK$(DIRSEP)lib$(DIRSEP)$(_TGTCPU)$(DIRSEP)$(WINCEDEBUG)$(DIRSEP)coredll.lib  \
                  $(_PROJECTROOT)$(DIRSEP)CESYSGEN$(DIRSEP)OAK$(DIRSEP)lib$(DIRSEP)$(_TGTCPU)$(DIRSEP)$(WINCEDEBUG)$(DIRSEP)ceddk.lib 

PROJ_RELEASE_DIR := $(_TARGETPLATROOT)$(DIRSEP)target$(DIRSEP)$(_TGTCPU)$(DIRSEP)$(WINCEDEBUG)



LINKER_SUBSYSTEM :=


LINKER_SUBSYSTEM +=/SUBSYSTEM:WINDOWSCE,6.00


#   ============================================================================
#   Rules to build targets
#   ============================================================================

target_deb  := $(addsuffix .deb, $(COMP_TARGET))
target_rel  := $(addsuffix .rel, $(COMP_TARGET))


#   ============================================================================
#   @rule   trgdeb
#
#   @desc   Builds the target for DEBUG variant.
#   ============================================================================

ifeq ("$(COMP_TYPE)", "LIB")
trgdeb  : libdeb
endif

ifeq ("$(COMP_TYPE)", "DRV")
trgdeb  : drvdeb
endif

ifeq ("$(COMP_TYPE)", "EXE")
trgdeb  : exedeb
endif


#   ============================================================================
#   @rule   trgrel
#
#   @desc   Builds the target for RELEASE variant.
#   ============================================================================

ifeq ("$(COMP_TYPE)", "LIB")
trgrel  : librel
endif

ifeq ("$(COMP_TYPE)", "DRV")
trgrel  : drvrel
endif

ifeq ("$(COMP_TYPE)", "EXE")
trgrel  : exerel
endif


#   ############################################################################
#   BUILD AN ARCHIVE
#   ############################################################################


ifeq ("$(COMP_TYPE)", "LIB")

#   ----------------------------------------------------------------------------
#   Name of the target archive & Library
#   ----------------------------------------------------------------------------

ARCHIVE_DEB   = $(COMP_BINARY_DEB)$(DIRSEP)$(basename $(@))
ARCHIVE_REL   = $(COMP_BINARY_REL)$(DIRSEP)$(basename $(@))

#   ----------------------------------------------------------------------------
#   Append suitable path to each user defined library
#   ----------------------------------------------------------------------------

ifeq ("$(USR_LIBS)", "")

USR_LIBS_DEB    :=
USR_LIBS_REL    :=

depend_deb      :=
depend_rel      :=

else

USR_LIBS_DEB    := $(addprefix $(BUILD_EXPORT_DEB)$(DIRSEP), $(USR_LIBS))
USR_LIBS_REL    := $(addprefix $(BUILD_EXPORT_REL)$(DIRSEP), $(USR_LIBS))

depend_deb      := $(addsuffix .dep, $(USR_LIBS_DEB))
depend_rel      := $(addsuffix .dep, $(USR_LIBS_REL))

endif

DEPENDS_DEB     := $(COMP_OBJECT_DEB)$(DIRSEP)DEPEND
DEPENDS_REL     := $(COMP_OBJECT_REL)$(DIRSEP)DEPEND

ARGS_ARCH_DEB   := $(COMP_OBJECT_DEB) $(DEPENDS_DEB)
ARGS_ARCH_REL   := $(COMP_OBJECT_REL) $(DEPENDS_REL)


CMD_ARCHIVE     := $(ARCHIVER) $(STD_AR_FLAGS)
CMD_LINK        := $(LD) $(LD_SW_RELOC)

#   ----------------------------------------------------------------------------
#   @rule   libdeb
#
#   @desc   Builds the target library for DEBUG variant.
#   ----------------------------------------------------------------------------

$(target_deb):
	$(CMDECHO)$(RUNIF) "exist $(EXPORT_INC_PLATFORM_USR)" "" "$(MKDIR) $(EXPORT_INC_PLATFORM_USR)"
	$(CMDECHO)$(COPYFILES) "$(PROJ_INC_USR)" "$(EXPORT_INC_PLATFORM_USR)" > $(TRASH)
	$(CMDECHO)$(RUNIF) "exist $(EXPORT_INC_PLATFORM_SYS)" "" "$(MKDIR) $(EXPORT_INC_PLATFORM_SYS)"
	$(CMDECHO)$(RUNIF) "exist $(EXPORT_INC_PLATFORM_SYS_ARCH)" "" "$(MKDIR) $(EXPORT_INC_PLATFORM_SYS_ARCH)"
	$(CMDECHO)$(COPYFILES) "$(PROJ_INC_ARCH)" "$(EXPORT_INC_PLATFORM_SYS_ARCH)" > $(TRASH)
	$(foreach device, $(TI_DSPLINK_DSPDEVICES), $(CMDECHO)$(RUNIF) "exist $(EXPORT_INC_PLATFORM_SYS_ARCH)$(DIRSEP)$(device)" "" "$(MKDIR) $(EXPORT_INC_PLATFORM_SYS_ARCH)$(DIRSEP)$(device)")
	$(foreach device, $(TI_DSPLINK_DSPDEVICES), $(CMDECHO)$(COPYFILES) "$(PROJ_INC_ARCH)$(DIRSEP)$(device)" "$(EXPORT_INC_PLATFORM_SYS_ARCH)$(DIRSEP)$(device)") > $(TRASH)
	$(CMDECHO)$(DISPLAY) Generating $(basename $@)...
	$(CMDECHO)$(CMD_ARCHIVE) -out:$(ARCHIVE_DEB) $(foreach dir, $(ARGS_ARCH_DEB), $(wildcard $(dir)/*.o)) $(USR_LIBS_DEB)
	$(CMDECHO)$(COPY) $(ARCHIVE_DEB) $(BUILD_EXPORT_DEB)$(DIRSEP).
	$(CMDECHO)$(COPY) $(COMP_OBJECT_DEB)$(DIRSEP)*.pdb $(BUILD_EXPORT_DEB)$(DIRSEP). >$(TRASH)
ifeq ("$(COMP_NAME)","API")
	$(CMDECHO)$(COPY) $(COMP_OBJECT_DEB)$(DIRSEP)*.pdb $(EXPORT_BIN_DEB)$(DIRSEP). >$(TRASH)
endif


libdeb  : $(target_deb)


#   ----------------------------------------------------------------------------
#   @rule   librel
#
#   @desc   Builds the target library for RELEASE variant.
#   ----------------------------------------------------------------------------

$(target_rel):
	$(CMDECHO)$(RUNIF) "exist $(EXPORT_INC_PLATFORM_USR)" "" "$(MKDIR) $(EXPORT_INC_PLATFORM_USR)"
	$(CMDECHO)$(COPYFILES) "$(PROJ_INC_USR)" "$(EXPORT_INC_PLATFORM_USR)" > $(TRASH)
	$(CMDECHO)$(RUNIF) "exist $(EXPORT_INC_PLATFORM_SYS)" "" "$(MKDIR) $(EXPORT_INC_PLATFORM_SYS)"
	$(CMDECHO)$(RUNIF) "exist $(EXPORT_INC_PLATFORM_SYS_ARCH)" "" "$(MKDIR) $(EXPORT_INC_PLATFORM_SYS_ARCH)"
	$(CMDECHO)$(COPYFILES) "$(PROJ_INC_ARCH)" "$(EXPORT_INC_PLATFORM_SYS_ARCH)" > $(TRASH)
	$(foreach device, $(TI_DSPLINK_DSPDEVICES), $(CMDECHO)$(RUNIF) "exist $(EXPORT_INC_PLATFORM_SYS_ARCH)$(DIRSEP)$(device)" "" "$(MKDIR) $(EXPORT_INC_PLATFORM_SYS_ARCH)$(DIRSEP)$(device)")
	$(foreach device, $(TI_DSPLINK_DSPDEVICES), $(CMDECHO)$(COPYFILES) "$(PROJ_INC_ARCH)$(DIRSEP)$(device)" "$(EXPORT_INC_PLATFORM_SYS_ARCH)$(DIRSEP)$(device)" > $(TRASH))
	$(CMDECHO)$(DISPLAY) Generating $(basename $@)...
	$(CMDECHO)$(CMD_ARCHIVE) -out:$(ARCHIVE_REL) $(foreach dir, $(ARGS_ARCH_REL), $(wildcard $(dir)/*.o)) $(USR_LIBS_REL)
	$(CMDECHO)$(COPY) $(ARCHIVE_REL) $(BUILD_EXPORT_REL)$(DIRSEP).
	
librel  : $(target_rel)


endif   # ifeq ("$(COMP_TYPE)", "LIB")


#   ############################################################################
#   BUILD A DRIVER MODULE
#   ############################################################################


ifeq ("$(COMP_TYPE)", "DRV")
#   ----------------------------------------------------------------------------
#   Name of the target driver module
#   ----------------------------------------------------------------------------
DRIVER_DEB   = $(COMP_BINARY_DEB)$(DIRSEP)$(basename $(@))
DRIVER_REL   = $(COMP_BINARY_REL)$(DIRSEP)$(basename $(@))

#   ----------------------------------------------------------------------------
#   Append suitable path to each user defined library
#   ----------------------------------------------------------------------------

ifeq ("$(USR_LIBS)", "")

USR_LIBS_DEB    :=
USR_LIBS_REL    :=

else

USR_LIBS_DEB    := $(addprefix $(BUILD_EXPORT_DEB)$(DIRSEP), $(USR_LIBS))
USR_LIBS_REL    := $(addprefix $(BUILD_EXPORT_REL)$(DIRSEP), $(USR_LIBS))

endif

DEPENDS_DEB     := $(COMP_OBJECT_DEB)$(DIRSEP)DEPEND
DEPENDS_REL     := $(COMP_OBJECT_REL)$(DIRSEP)DEPEND

ARGS_ARCH_DEB   := $(COMP_OBJECT_DEB) $(DEPENDS_DEB)
ARGS_ARCH_REL   := $(COMP_OBJECT_REL) $(DEPENDS_REL)


CMD_LINK        := $(LD) $(STD_LD_FLAGS) $(DRV_LD_FLAGS)   



#   ----------------------------------------------------------------------------
#   @rule   drvdeb
#
#   @desc   Builds the target driver module for DEBUG variant.
#   ----------------------------------------------------------------------------

$(target_deb):
	$(CMDECHO)$(DISPLAY) Generating $(basename $@)...
	$(CMDECHO)$(COPYFILES) "$(PROJ_INC_BUILDOS)" "$(EXPORT_INC_PLATFORM)$(DIRSEP)internal" > $(TRASH)
	$(CMDECHO)$(CMD_LINK) -dll $(LD_SW_OUT)$(COMP_BINARY_DEB)$(DIRSEP)$(COMP_TARGET).dll -pdb:$(COMP_OBJECT_DEB)$(DIRSEP)$(COMP_TARGET).pdb -map:$(COMP_OBJECT_DEB)$(DIRSEP)$(COMP_TARGET).map -mapinfo:exports -savebaserelocations:$(COMP_OBJECT_DEB)$(DIRSEP)$(COMP_TARGET).rel $(foreach dir, $(ARGS_ARCH_DEB), $(wildcard $(dir)/*.o)) $(TARGETLIBS_DEB) $(USR_LIBS_DEB) 
	$(CMDECHO)$(DISPLAY) Post processing kernel module $(basename $(basename $@))...
	$(CMDECHO)$(COPY) $(COMP_BINARY_DEB)$(DIRSEP)*.* $(BUILD_EXPORT_DEB)$(DIRSEP).
	$(CMDECHO)$(COPY) $(COMP_OBJECT_DEB)$(DIRSEP)*.map $(BUILD_EXPORT_DEB)$(DIRSEP).
	$(CMDECHO)$(COPY) $(COMP_OBJECT_DEB)$(DIRSEP)*.pdb $(BUILD_EXPORT_DEB)$(DIRSEP).
	$(CMDECHO)$(RUNIF) "exist $(PROJ_RELEASE_DIR)$(DIRSEP)" "$(DELETE) $(PROJ_RELEASE_DIR)$(DIRSEP)$(basename $@).*" "" >$(TRASH)
	$(CMDECHO)$(COPY) $(COMP_BINARY_DEB)$(DIRSEP)*.dll $(PROJ_RELEASE_DIR)$(DIRSEP).
	$(CMDECHO)$(COPY) $(COMP_OBJECT_DEB)$(DIRSEP)*.map $(PROJ_RELEASE_DIR)$(DIRSEP).
	$(CMDECHO)$(COPY) $(COMP_OBJECT_DEB)$(DIRSEP)*.pdb $(PROJ_RELEASE_DIR)$(DIRSEP).


drvdeb  : $(target_deb)


#   ----------------------------------------------------------------------------
#   @rule   drvrel
#
#   @desc   Builds the target driver module for RELEASE variant.
#   ----------------------------------------------------------------------------

$(target_rel):
	$(CMDECHO)$(DISPLAY) Generating $(basename $@)...
	$(CMDECHO)$(CMD_LINK) -dll $(LD_SW_OUT)$(COMP_BINARY_REL)$(DIRSEP)$(COMP_TARGET).dll -pdb:$(COMP_OBJECT_REL)$(DIRSEP)$(COMP_TARGET).pdb -map:$(COMP_OBJECT_REL)$(DIRSEP)$(COMP_TARGET).map -mapinfo:exports -savebaserelocations:$(COMP_OBJECT_REL)$(DIRSEP)$(COMP_TARGET).rel $(foreach dir, $(ARGS_ARCH_REL), $(wildcard $(dir)/*.o)) $(USR_LIBS_REL) $(TARGETLIBS_REL) 
	$(CMDECHO)$(DISPLAY) Post processing kernel module $(basename $(basename $@))...
	$(CMDECHO)$(COPY) $(COMP_BINARY_REL)$(DIRSEP)*.* $(BUILD_EXPORT_REL)$(DIRSEP).
	$(CMDECHO)$(COPY) $(COMP_OBJECT_REL)$(DIRSEP)*.map $(BUILD_EXPORT_REL)$(DIRSEP).
	$(CMDECHO)$(COPY) $(COMP_OBJECT_REL)$(DIRSEP)*.pdb $(BUILD_EXPORT_REL)$(DIRSEP).
	$(CMDECHO)$(RUNIF) "exist $(PROJ_RELEASE_DIR)$(DIRSEP)" "$(DELETE) $(PROJ_RELEASE_DIR)$(DIRSEP)$(basename $@).*" "" >$(TRASH)	
	$(CMDECHO)$(COPY) $(COMP_BINARY_REL)$(DIRSEP)*.dll $(PROJ_RELEASE_DIR)$(DIRSEP).
	$(CMDECHO)$(COPY) $(COMP_OBJECT_REL)$(DIRSEP)*.map $(PROJ_RELEASE_DIR)$(DIRSEP).
	$(CMDECHO)$(COPY) $(COMP_OBJECT_REL)$(DIRSEP)*.pdb $(PROJ_RELEASE_DIR)$(DIRSEP).

drvrel  : $(target_rel)

endif   # ifeq ("$(COMP_TYPE)", "DRV")


#   ############################################################################
#   BUILD AN EXECUTABLE
#   ############################################################################


ifeq ("$(COMP_TYPE)", "EXE")
#   ----------------------------------------------------------------------------
#   Name of the target executable
#   ----------------------------------------------------------------------------
EXECUTABLE_DEB   = $(COMP_BINARY_DEB)$(DIRSEP)$(basename $(@))
EXECUTABLE_REL   = $(COMP_BINARY_REL)$(DIRSEP)$(basename $(@))

#   ----------------------------------------------------------------------------
#   Append suitable path to each user defined library
#   ----------------------------------------------------------------------------

ifeq ("$(USR_LIBS)", "")

USR_LIBS_DEB  :=
USR_LIBS_REL  :=

else

USR_LIBS_DEB  := $(addprefix $(BUILD_EXPORT_DEB)$(DIRSEP), $(USR_LIBS))
USR_LIBS_REL  := $(addprefix $(BUILD_EXPORT_REL)$(DIRSEP), $(USR_LIBS))

endif

DEPENDS_DEB   := $(COMP_OBJECT_DEB)$(DIRSEP)DEPEND
DEPENDS_REL   := $(COMP_OBJECT_REL)$(DIRSEP)DEPEND

ARGS_ARCH_DEB := $(COMP_OBJECT_DEB) $(DEPENDS_DEB)
ARGS_ARCH_REL := $(COMP_OBJECT_REL) $(DEPENDS_REL)

CMD_LINK      := $(LINKER) $(SPECIFIC_LD_FLAGS) $(EXE_LD_FLAGS) $(STD_LD_FLAGS) $(USR_LD_FLAGS) 

#   ----------------------------------------------------------------------------
#   @rule   exedeb
#
#   @desc   Builds the target executable for DEBUG variant.
#   ----------------------------------------------------------------------------

$(target_deb):
	$(CMDECHO)$(DISPLAY) Generating $(basename $@)...
	$(CMDECHO)$(CMD_LINK) $(LD_SW_OUT)$(COMP_BINARY_DEB)$(DIRSEP)$(basename $(@)).exe -savebaserelocations:$(COMP_OBJECT_DEB)$(DIRSEP)$(COMP_TARGET).rel -pdb:$(COMP_OBJECT_DEB)$(DIRSEP)$(COMP_TARGET).pdb -map:$(COMP_OBJECT_DEB)$(DIRSEP)$(COMP_TARGET).map -mapinfo:exports $(foreach dir, $(ARGS_ARCH_DEB), $(wildcard $(dir)/*.o)) $(SOURCELIBS_DEB) $(USR_LIBS_DEB)
	$(CMDECHO)$(COPY) $(COMP_BINARY_DEB)$(DIRSEP)*.* $(BUILD_EXPORT_DEB)$(DIRSEP).
	$(CMDECHO)$(COPY) $(COMP_OBJECT_DEB)$(DIRSEP)*.map $(BUILD_EXPORT_DEB)$(DIRSEP).
	$(CMDECHO)$(COPY) $(COMP_OBJECT_DEB)$(DIRSEP)*.pdb $(BUILD_EXPORT_DEB)$(DIRSEP).
	$(CMDECHO)$(RUNIF) "exist $(PROJ_RELEASE_DIR)$(DIRSEP)" "$(DELETE) $(PROJ_RELEASE_DIR)$(DIRSEP)$(basename $@).*" "" >$(TRASH)	
	$(CMDECHO)$(COPY) $(COMP_BINARY_DEB)$(DIRSEP)*.exe $(PROJ_RELEASE_DIR)$(DIRSEP).
	$(CMDECHO)$(COPY) $(COMP_OBJECT_DEB)$(DIRSEP)*.map $(PROJ_RELEASE_DIR)$(DIRSEP).
	$(CMDECHO)$(COPY) $(COMP_OBJECT_DEB)$(DIRSEP)*.pdb $(PROJ_RELEASE_DIR)$(DIRSEP).
	
exedeb  : $(target_deb)


#   ----------------------------------------------------------------------------
#   @rule   exerel
#
#   @desc   Builds the target executable for RELEASE variant.
#   ----------------------------------------------------------------------------

$(target_rel):
	$(CMDECHO)$(DISPLAY) Generating $(basename $@)...
	$(CMDECHO)$(CMD_LINK) $(LD_SW_OUT)$(COMP_BINARY_REL)$(DIRSEP)$(basename $(@)).exe -savebaserelocations:$(COMP_OBJECT_REL)$(DIRSEP)$(COMP_NAME).rel -pdb:$(COMP_OBJECT_REL)$(DIRSEP)$(COMP_TARGET).pdb -map:$(COMP_OBJECT_REL)$(DIRSEP)$(COMP_TARGET).map -mapinfo:exports $(foreach dir, $(ARGS_ARCH_REL), $(wildcard $(dir)/*.o)) $(SOURCELIBS_REL) $(USR_LIBS_REL)
	$(CMDECHO)$(COPY) $(COMP_BINARY_REL)$(DIRSEP)*.* $(BUILD_EXPORT_REL)$(DIRSEP).
	$(CMDECHO)$(COPY) $(COMP_OBJECT_REL)$(DIRSEP)*.map $(BUILD_EXPORT_REL)$(DIRSEP).
	$(CMDECHO)$(COPY) $(COMP_OBJECT_REL)$(DIRSEP)*.pdb $(BUILD_EXPORT_REL)$(DIRSEP).
	$(CMDECHO)$(RUNIF) "exist $(PROJ_RELEASE_DIR)$(DIRSEP)" "$(DELETE) $(PROJ_RELEASE_DIR)$(DIRSEP)$(basename $@).*" "" >$(TRASH)
	$(CMDECHO)$(COPY) $(COMP_BINARY_REL)$(DIRSEP)*.exe $(PROJ_RELEASE_DIR)$(DIRSEP).
	$(CMDECHO)$(COPY) $(COMP_OBJECT_REL)$(DIRSEP)*.map $(PROJ_RELEASE_DIR)$(DIRSEP).
	$(CMDECHO)$(COPY) $(COMP_OBJECT_REL)$(DIRSEP)*.pdb $(PROJ_RELEASE_DIR)$(DIRSEP).
	
exerel  : $(target_rel)

endif 
endif   # ifndef LINK_MK
